plugins {
    id("com.android.application")
    id("org.jetbrains.kotlin.android")
}

android {
    namespace = "com.example.libmedia.demo.video"
    compileSdk = 35

    defaultConfig {
        applicationId = "com.example.libmedia.demo.video"
        minSdk = 21  // min 21 otherwise 'Manifest merger failed' error with androidx.fragment:fragment:1.8.6
        targetSdk = 35
        versionCode = 6
        versionName = "2.3"
    }

    buildTypes {
        release {
            isMinifyEnabled = false
            proguardFiles(
                getDefaultProguardFile("proguard-android-optimize.txt"),
                "proguard-rules.pro"
            )
        }
    }

    // https://developer.android.com/build/jdks#toolchain
    java {
        toolchain {
            languageVersion = JavaLanguageVersion.of(21)
        }
    }
}

dependencies {
    implementation(fileTree("libs") { include("*.jar") })
    implementation("androidx.fragment:fragment-ktx:1.8.6")  // for StorageActivity
    implementation("androidx.documentfile:documentfile:1.0.1")  // needed for Storage Components of Libmedia library
    implementation("cz.msebera.android:httpclient:4.5.8")  // needed for Network Components of Libmedia library
}
